CREATE TABLE `[#DB_PREFIX#]active_tbl` (
  `active_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `expire_time` int(10) DEFAULT NULL,
  `active_code` varchar(32) DEFAULT NULL,
  `active_type` tinyint(4) DEFAULT NULL COMMENT '1 Activation Mail, 11 Forgot Password 1121 E-mail verification 22 Phone verification',
  `active_type_code` varchar(16) DEFAULT NULL,
  `active_values` text,
  `add_time` int(10) DEFAULT NULL,
  `add_ip` bigint(12) DEFAULT NULL,
  `active_expire` tinyint(1) DEFAULT NULL,
  `active_time` int(10) DEFAULT NULL,
  `active_ip` bigint(12) DEFAULT NULL,
  PRIMARY KEY (`active_id`),
  KEY `active_code` (`active_code`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]admin_group` (
  `group_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `group_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Group name',
  `menu` text NOT NULL COMMENT 'Visible columns',
  `no_menu` text,
  `permission` text NOT NULL COMMENT 'Competence',
  `no_permission` text,
  PRIMARY KEY (`group_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]answer` (
  `answer_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Answer id',
  `question_id` int(11) NOT NULL COMMENT 'Question id',
  `answer_content` text COMMENT 'Answer Content',
  `add_time` int(10) DEFAULT '0' COMMENT 'Add Time',
  `against_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Against persons',
  `agree_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Support persons',
  `uid` int(11) DEFAULT '0' COMMENT 'Publishing Issues User ID',
  `comment_count` int(11) DEFAULT '0' COMMENT 'Total Comments',
  `uninterested_count` int(11) DEFAULT '0' COMMENT 'Not interested',
  `thanks_count` int(11) DEFAULT '0' COMMENT 'Thank total',
  `category_id` int(11) DEFAULT '0' COMMENT 'Category id',
  `has_attach` tinyint(1) DEFAULT '0' COMMENT 'Existence attachments',
  `ip` bigint(11) DEFAULT NULL,
  `force_fold` TINYINT( 1 ) NULL DEFAULT '0' COMMENT 'Forced folding',
  `anonymous` TINYINT( 1 ) NULL DEFAULT '0',
  PRIMARY KEY (`answer_id`),
  KEY `question_id` (`question_id`),
  KEY `agree_count` (`agree_count`),
  KEY `against_count` (`against_count`),
  KEY `add_time` (`add_time`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8 COMMENT='Answer';

CREATE TABLE `[#DB_PREFIX#]approval` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `type` varchar(16) DEFAULT NULL,
  `data` mediumtext NOT NULL,
  `uid` int(11) NOT NULL DEFAULT '0',
  `time` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `uid` (`uid`),
  KEY `time` (`time`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]attach` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `file_name` varchar(255) DEFAULT NULL COMMENT 'Attachment Name',
  `access_key` varchar(32) DEFAULT NULL COMMENT 'Batch Key',
  `add_time` int(10) DEFAULT '0' COMMENT 'Update',
  `file_location` varchar(255) DEFAULT NULL COMMENT 'File Location',
  `is_image` int(1) DEFAULT '0',
  `item_type` varchar(32) DEFAULT '0' COMMENT 'Association type',
  `item_id` int(11) DEFAULT '0' COMMENT 'Correlation ID',
  `wait_approval` TINYINT( 1 ) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `access_key` (`access_key`),
  KEY `is_image` (`is_image`),
  KEY `fetch` (`item_id`,`item_type`),
  KEY `wait_approval` (`wait_approval`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]answer_comments` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `answer_id` int(11) DEFAULT '0',
  `uid` int(11) DEFAULT '0',
  `message` varchar(255) DEFAULT NULL,
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `answer_id` (`answer_id`),
  KEY `time` (`time`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]answer_thanks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `answer_id` int(11) DEFAULT '0',
  `user_name` varchar(255) DEFAULT NULL,
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `answer_id` (`answer_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]answer_uninterested` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `answer_id` int(11) DEFAULT '0',
  `user_name` varchar(255) DEFAULT NULL,
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `answer_id` (`answer_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]answer_vote` (
  `voter_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Auto-ID',
  `answer_id` int(11) DEFAULT NULL COMMENT 'Reply id',
  `answer_uid` int(11) DEFAULT NULL COMMENT 'Reply author id',
  `vote_uid` int(11) DEFAULT NULL COMMENT 'User ID',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `vote_value` tinyint(4) NOT NULL COMMENT '-1 Against 1 Support',
  `reputation_factor` int(10) DEFAULT '0',
  PRIMARY KEY (`voter_id`),
  KEY `answer_id` (`answer_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]cache` (
  `key` varchar(255) NOT NULL DEFAULT '',
  `data` text,
  `expire` int(10) DEFAULT NULL,
  PRIMARY KEY (`key`),
  KEY `expire` (`expire`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]category` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(128) DEFAULT NULL,
  `type` varchar(16) DEFAULT NULL,
  `icon` varchar(255) DEFAULT NULL,
  `parent_id` int(11) DEFAULT '0',
  `sort` SMALLINT(6) DEFAULT '0',
  `url_token` VARCHAR( 32 ) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `url_token` (`url_token`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]draft` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `type` varchar(16) DEFAULT NULL,
  `item_id` int(11) DEFAULT NULL,
  `data` text,
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `item_id` (`item_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]education_experience` (
  `education_id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL COMMENT 'User UID',
  `education_years` int(11) DEFAULT NULL COMMENT 'Start year',
  `school_name` varchar(64) DEFAULT NULL COMMENT 'School name',
  `school_type` tinyint(4) DEFAULT NULL COMMENT 'School Type',
  `departments` varchar(64) DEFAULT NULL COMMENT 'Departments',
  `add_time` int(10) DEFAULT NULL COMMENT 'Record Add Time',
  PRIMARY KEY (`education_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Education';

CREATE TABLE `[#DB_PREFIX#]feature` (
	`id` INT( 11 ) NULL AUTO_INCREMENT ,
	`title` VARCHAR( 200 ) NULL DEFAULT NULL COMMENT 'Title of the topic',
	`description` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Description of project',
	`icon` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Thematic Icons',
	`topic_count` INT( 11 ) NULL DEFAULT '0' COMMENT 'Thread count',
	`css` TEXT NULL DEFAULT NULL COMMENT 'Custom CSS',
	`url_token` VARCHAR( 32 ) NULL DEFAULT NULL,
	PRIMARY KEY ( `id` ),
	KEY `url_token` (`url_token`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]feature_topic` (
	`id` INT( 11 ) NULL AUTO_INCREMENT ,
	`feature_id` INT( 11 ) NULL DEFAULT '0' COMMENT 'Thematic ID',
	`topic_id` INT( 11 ) NULL DEFAULT '0' COMMENT 'Topic ID',
	PRIMARY KEY ( `id` ),
	KEY `feature_id` (`feature_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]favorite` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `answer_id` int(11) DEFAULT '0',
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `answer_id` (`answer_id`),
  KEY `time` (`time`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]favorite_tag` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `title` varchar(128) DEFAULT NULL,
  `answer_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]invitation` (
  `invitation_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Activation ID',
  `uid` int(11) DEFAULT '0' COMMENT 'User ID',
  `invitation_code` varchar(32) DEFAULT NULL COMMENT 'Activation',
  `invitation_email` varchar(255) DEFAULT NULL COMMENT 'Activation email',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `add_ip` bigint(12) DEFAULT NULL COMMENT 'Add IP',
  `active_expire` tinyint(1) DEFAULT '0' COMMENT 'Activation Expired',
  `active_time` int(10) DEFAULT NULL COMMENT 'Activation time',
  `active_ip` bigint(12) DEFAULT NULL COMMENT 'Activate IP',
  `active_status` tinyint(4) DEFAULT '0' COMMENT '1 has 0 Unused -1 has been deleted',
  `active_uid` int(11) DEFAULT NULL,
  PRIMARY KEY (`invitation_id`),
  KEY `uid` (`uid`),
  KEY `invitation_code` (`invitation_code`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]jobs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `job_name` varchar(64) DEFAULT NULL COMMENT 'Job name',
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]integral_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `action` varchar(16) DEFAULT NULL,
  `integral` int(11) DEFAULT NULL,
  `note` varchar(128) DEFAULT NULL,
  `balance` int(11) DEFAULT '0',
  `item_id` int(11) DEFAULT '0',
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `action` (`action`),
  KEY `time` (`time`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]login` (
  `id` int(11) NOT NULL COMMENT 'Increment ID',
  `uid` int(11) DEFAULT NULL COMMENT 'User ID',
  `login_time` int(10) DEFAULT NULL COMMENT 'Login Time',
  `login_type` tinyint(4) DEFAULT NULL COMMENT 'Logon Type',
  `login_ip` bigint(12) DEFAULT NULL COMMENT 'Login IP',
  `login_rs` tinyint(4) DEFAULT NULL COMMENT 'Results 1 success, -1 on failure, 0, unknown',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8 COMMENT='Sign in history table';

CREATE TABLE `[#DB_PREFIX#]nav_menu` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(128) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `type` varchar(16) DEFAULT NULL,
  `type_id` int(11) DEFAULT '0',
  `link` varchar(255) DEFAULT NULL COMMENT 'Link',
  `icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `sort` smallint(6) DEFAULT '0' COMMENT 'Sequence',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`link`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]notice` (
  `notice_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `sender_uid` int(11) DEFAULT NULL COMMENT 'Sender ID',
  `dialog_id` int(11) DEFAULT NULL COMMENT 'Session id',
  `notice_title` varchar(64) DEFAULT NULL COMMENT 'Title',
  `notice_content` text COMMENT 'Content',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `notice_type` tinyint(4) DEFAULT NULL COMMENT '0-General News 10-System made the news, can not reply to 11-System Notifications',
  PRIMARY KEY (`notice_id`),
  KEY (`dialog_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]notice_dialog` (
  `dialog_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Dialogue ID',
  `sender_uid` int(11) DEFAULT NULL COMMENT 'Sender UID',
  `sender_unread` int(11) DEFAULT NULL COMMENT 'Sender Unread',
  `recipient_uid` int(11) DEFAULT NULL COMMENT 'UID recipient',
  `recipient_unread` int(11) DEFAULT NULL COMMENT 'Recipient Unread',
  `add_time` int(11) DEFAULT NULL COMMENT 'Add Time',
  `last_time` int(11) DEFAULT NULL COMMENT 'Last updated',
  `last_notice_id` int(11) DEFAULT NULL COMMENT 'Finally a short message ID',
  `sender_count` int(11) DEFAULT NULL COMMENT 'Display sender count',
  `recipient_count` int(11) DEFAULT NULL COMMENT 'Display recipients dialogue',
  `all_count` int(11) DEFAULT NULL COMMENT 'Total count of dialogue',
  PRIMARY KEY (`dialog_id`),
  KEY (`recipient_uid`),
  KEY (`sender_uid`),
  KEY (`last_time`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]notice_recipient` (
  `recipient_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `notice_id` int(11) DEFAULT NULL COMMENT 'Message ID',
  `dialog_id` int(11) DEFAULT NULL COMMENT 'Dialogue ID, timestamp',
  `sender_uid` int(11) DEFAULT NULL COMMENT 'Sender UID',
  `sender_time` int(11) DEFAULT NULL COMMENT 'Delivery time',
  `sender_del` tinyint(4) DEFAULT NULL COMMENT 'Remove sender',
  `recipient_uid` int(11) DEFAULT NULL COMMENT 'UID recipient',
  `recipient_time` int(11) DEFAULT NULL COMMENT 'Receive time',
  `recipient_del` tinyint(4) DEFAULT NULL COMMENT 'Remove receiver',
  PRIMARY KEY (`recipient_id`),
  KEY (`recipient_uid`),
  KEY (`sender_uid`),
  KEY (`notice_id`),
  KEY (`dialog_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]notification` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `sender_uid` int(11) DEFAULT NULL COMMENT 'Sender ID',
  `recipient_uid` int(11) DEFAULT '0' COMMENT 'Recipient ID',
  `action_type` int(4) DEFAULT NULL COMMENT 'Type operation',
  `model_type` smallint(11) NOT NULL DEFAULT '0',
  `source_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Questions or game ID',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `read_flag` TINYINT( 1 ) NULL DEFAULT '0' COMMENT 'Read status',
  PRIMARY KEY (`notification_id`),
  KEY `recipient_read_flag` (`recipient_uid`,`read_flag`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='System Notifications';

CREATE TABLE `[#DB_PREFIX#]notification_data` (
  `notification_id` int(11) unsigned NOT NULL,
  `data` text,
  PRIMARY KEY (`notification_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8 COMMENT='System Notifications Data Sheet';

CREATE TABLE `[#DB_PREFIX#]question` (
  `question_id` int(11) NOT NULL AUTO_INCREMENT,
  `question_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'Questions Content',
  `question_detail` text COMMENT 'Description of the problem',
  `add_time` int(11) NOT NULL COMMENT 'Add Time',
  `update_time` int(11) DEFAULT NULL,
  `published_uid` int(11) DEFAULT NULL COMMENT 'Post User UID',
  `answer_count` int(11) DEFAULT '0' COMMENT 'Answer Count',
  `answer_users` int(11) DEFAULT '0' COMMENT 'Answer Number',
  `view_count` int(11) DEFAULT '0' COMMENT 'Views',
  `focus_count` int(11) DEFAULT '0' COMMENT 'Attention',
  `comment_count` int(11) DEFAULT '0' COMMENT 'Comments',
  `action_history_id` int(11) DEFAULT '0' COMMENT 'Actions related record table id',
  `category_id` int(11) DEFAULT '0' COMMENT 'Category ID',
  `agree_count` int(11) DEFAULT '0' COMMENT 'Reply to endorse the sum',
  `against_count` int(11) DEFAULT '0' COMMENT 'Back against the sum',
  `best_answer` int(11) DEFAULT '0' COMMENT 'Best Reply ID',
  `has_attach` tinyint(1) DEFAULT '0' COMMENT 'Existence attachments',
  `unverified_modify` text,
  `ip` bigint(11) DEFAULT NULL,
  `last_answer` int(11) DEFAULT '0' COMMENT 'Last Answer ID',
  `popular_value` DOUBLE NULL DEFAULT '0',
  `popular_value_update` INT( 10 ) NULL DEFAULT '0',
  `lock` TINYINT( 1 ) NULL DEFAULT '0' COMMENT 'Whether to lock',
  `anonymous` TINYINT( 1 ) NULL DEFAULT '0',
  `thanks_count` INT( 10 ) NULL DEFAULT '0',
  `question_content_fulltext` VARCHAR( 128 ) NULL DEFAULT '',
  PRIMARY KEY (`question_id`),
  KEY `category_id` (`category_id`),
  KEY `update_time` (`update_time`),
  KEY `add_time` (`add_time`),
  KEY `published_uid` (`published_uid`),
  KEY `answer_count` (`answer_count`),
  KEY `question_content` (`question_content`),
  KEY `lock` (`lock`),
  KEY `thanks_count` (`thanks_count`),
  FULLTEXT KEY `question_content_fulltext` (`question_content_fulltext`)
) ENGINE=MYISAM DEFAULT CHARSET=utf8 COMMENT='List of question';

CREATE TABLE `[#DB_PREFIX#]question_thanks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `question_id` int(11) DEFAULT '0',
  `user_name` varchar(255) DEFAULT NULL,
  `time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `question_id` (`question_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]question_comments` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `question_id` int(11) DEFAULT '0',
  `uid` int(11) DEFAULT '0',
  `message` varchar(255) DEFAULT NULL,
  `time` int(10) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `question_id` (`question_id`),
  KEY `time` (`time`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]question_focus` (
  `focus_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `question_id` int(11) DEFAULT NULL COMMENT 'Topic ID',
  `uid` int(11) DEFAULT NULL COMMENT 'User UID',
  `add_time` int(10) DEFAULT NULL,
  PRIMARY KEY (`focus_id`),
  KEY `question_id` (`question_id`),
  KEY `question_uid` ( `question_id`, `uid` )
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Concern Table';

CREATE TABLE `[#DB_PREFIX#]question_invite` (
  `question_invite_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `question_id` int(11) NOT NULL COMMENT 'Question ID',
  `sender_uid` int(11) NOT NULL,
  `recipients_uid` INT(11) NULL DEFAULT NULL,
  `email` VARCHAR(255) NULL DEFAULT NULL COMMENT 'Invited Email',
  `add_time` int(10) DEFAULT '0' COMMENT 'Add Time',
  `available_time` int(10) DEFAULT '0' COMMENT 'Effective Time',
  PRIMARY KEY (`question_invite_id`),
  KEY `question_id` (`question_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Invite Answers';

CREATE TABLE `[#DB_PREFIX#]question_uninterested` (
  `interested_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `question_id` int(11) DEFAULT NULL COMMENT 'Topic ID',
  `uid` int(11) DEFAULT NULL COMMENT 'User UID',
  `add_time` int(10) DEFAULT NULL,
  PRIMARY KEY (`interested_id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Question Not interested table';

CREATE TABLE `[#DB_PREFIX#]report` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0' COMMENT 'Report user id',
  `type` varchar(50) DEFAULT NULL COMMENT 'Category',
  `target_id` int(11) DEFAULT '0' COMMENT 'ID',
  `reason` varchar(255) DEFAULT NULL COMMENT 'Report grounds',
  `url` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT '0' COMMENT 'Report Time',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Whether to deal',
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]reputation_topic` (
  `auto_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `topic_id` int(11) DEFAULT '0' COMMENT 'Topic ID',
  `topic_count` int(10) DEFAULT '0' COMMENT 'Thread count reputation issue',
  `update_time` int(10) DEFAULT NULL COMMENT 'Updated',
   `agree_count` INT(10) DEFAULT '0' COMMENT 'Approve',
  `thanks_count` INT(10) DEFAULT '0' COMMENT 'Thank',
  `best_answer_count` INT(10) DEFAULT '0' COMMENT 'Best Reply',
  `reputation` INT(10) DEFAULT '0',
  PRIMARY KEY (`auto_id`),
  KEY `topic_count` (`topic_count`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]related_topic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `topic_id` int(11) DEFAULT '0' COMMENT 'Topic ID',
  `related_id` int(11) DEFAULT '0' COMMENT 'Related Topic ID',
  PRIMARY KEY (`id`),
  KEY `topic_id` (`topic_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]school` (
  `school_id` int(11) NOT NULL COMMENT 'Increment ID',
  `school_type` tinyint(4) DEFAULT NULL COMMENT 'School type ID',
  `school_code` int(11) DEFAULT NULL COMMENT 'Coding Schools',
  `school_name` varchar(64) DEFAULT NULL COMMENT 'School name says',
  `area_code` int(11) DEFAULT NULL COMMENT 'Area Code',
  PRIMARY KEY (`school_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8 COMMENT='School';

CREATE TABLE `[#DB_PREFIX#]system_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `varname` VARCHAR( 255 ) NOT NULL COMMENT 'Field name',
  `value` text COMMENT 'Variable value',
  PRIMARY KEY (`id`),
  UNIQUE KEY `varname` (`varname`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='System Settings';

CREATE TABLE `[#DB_PREFIX#]topic` (
  `topic_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Topic id',
  `topic_title` varchar(64) DEFAULT NULL COMMENT 'Topic Title',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `discuss_count` int(11) DEFAULT '0' COMMENT 'Discussion Count',
  `topic_description` text COMMENT 'Topic Description',
  `topic_pic` varchar(255) DEFAULT NULL COMMENT 'Topic Image',
  `topic_lock` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Whether the topic to lock 1 Locking 0 Unlocked',
  `focus_count` int(11) DEFAULT '0' COMMENT 'Follow counting',
  `user_related` tinyint(1) DEFAULT '0' COMMENT 'Is associated by the user',
  `url_token` VARCHAR(32) DEFAULT NULL,
  PRIMARY KEY (`topic_id`),
  UNIQUE KEY `topic_title` (`topic_title`),
  KEY `url_token` (`url_token`)
) ENGINE=MYISAM DEFAULT CHARSET=utf8 COMMENT='Topics';

CREATE TABLE `[#DB_PREFIX#]topic_focus` (
  `focus_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `topic_id` int(11) DEFAULT NULL COMMENT 'Topic ID',
  `uid` int(11) DEFAULT NULL COMMENT 'User UID',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  PRIMARY KEY (`focus_id`),
  KEY `uid` (`uid`),
  KEY `topic_id` ( `topic_id` ),
  KEY `topic_uid` ( `topic_id`, `uid` )
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Topics concern form';

CREATE TABLE `[#DB_PREFIX#]topic_question` (
  `topic_question_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `topic_id` int(11) DEFAULT '0' COMMENT 'Topic id',
  `question_id` int(11) DEFAULT '0' COMMENT 'Question ID',
  `add_time` int(10) DEFAULT '0' COMMENT 'Add Time',
  `uid` int(11) DEFAULT '0' COMMENT 'User ID',
  PRIMARY KEY (`topic_question_id`),
  KEY `topic_id` ( `topic_id` ),
  KEY `question_id` ( `question_id` ),
  KEY `uid` ( `uid` )
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users` (
  `uid` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Users UID',
  `user_name` varchar(50) DEFAULT NULL COMMENT 'User name',
  `email` varchar(255) DEFAULT NULL COMMENT 'EMAIL',
  `mobile` varchar(50) DEFAULT NULL COMMENT 'Mobile phone users',
  `password` varchar(50) DEFAULT NULL COMMENT 'User password',
  `salt` varchar(50) DEFAULT NULL COMMENT 'Additional confuse the user code',
  `avatar_file` varchar(50) DEFAULT NULL COMMENT 'Picture File',
  `sex` tinyint(4) DEFAULT NULL COMMENT 'Gender',
  `birthday` int(11) DEFAULT NULL COMMENT 'Users birthday',
  `country` int(11) DEFAULT NULL COMMENT 'National ID',
  `province` VARCHAR( 40 ) NULL DEFAULT NULL COMMENT 'Provincial ID',
  `city` VARCHAR( 40 ) NULL DEFAULT NULL COMMENT 'City ID',
  `job_id` int(11) DEFAULT '0' COMMENT 'Occupational ID',
  `reg_time` int(11) DEFAULT NULL COMMENT 'Registered',
  `reg_ip` bigint(12) DEFAULT NULL COMMENT 'Register IP',
  `last_login` int(10) DEFAULT '0' COMMENT 'Last Login Time',
  `last_ip` bigint(12) DEFAULT NULL COMMENT 'Last login IP',
  `online_time` int(11) DEFAULT '0' COMMENT 'Online (Minute)',
  `last_active` INT(11) DEFAULT NULL COMMENT 'Last active time',
  `notification_unread` int(11) NOT NULL DEFAULT '0' COMMENT 'Unread System Notifications',
  `notice_unread` int(11) NOT NULL DEFAULT '0' COMMENT 'Unread message',
  `inbox_recv` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0-Everyone can be sent to me,1-People Im Following',
  `fans_count` int(10) NOT NULL DEFAULT '0' COMMENT 'Number of fans',
  `friend_count` int(10) NOT NULL DEFAULT '0' COMMENT 'Number of spectators',
  `invite_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Ask me the number',
  `question_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Total Questions',
  `answer_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Answer Questions',
  `topic_focus_count` int(11) NOT NULL DEFAULT '0' COMMENT 'TopicsAttention amount',
  `invitation_available` int(11) NOT NULL DEFAULT '0' COMMENT 'Inviting places',
  `group_id` smallint(5) DEFAULT '0' COMMENT 'User Groups',
  `reputation_group` tinyint(3) DEFAULT '0' COMMENT 'Reputation group',
  `forbidden` tinyint(3) DEFAULT '0' COMMENT 'Whether to prohibit users',
  `valid_email` tinyint(2) DEFAULT '0' COMMENT 'E-mail verification',
  `is_first_login` tinyint(1) DEFAULT '1' COMMENT 'Mark first login',
  `agree_count` int(11) DEFAULT '0' COMMENT 'Agreed quantity',
  `thanks_count` int(11) DEFAULT '0' COMMENT 'Thank total',
  `views_count` int(11) DEFAULT '0' COMMENT 'View Profile quantity',
  `reputation` int(11) DEFAULT '0' COMMENT 'Personal reputation value',
  `reputation_update_time` int(11) DEFAULT NULL COMMENT 'Personal reputation valueUpdated',
  `socialnet_visit` tinyint(1) NULL DEFAULT '1' COMMENT 'Microblogging allows access',
  `integral` int(11) DEFAULT '0',
  `draft_count` int(11) DEFAULT '0',
  `url_token` VARCHAR(32) DEFAULT NULL,
  `url_token_update` int(10) DEFAULT '0',
  `common_email` VARCHAR(255) NULL DEFAULT NULL COMMENT 'Public mail',
  `verified` TINYINT( 1 ) NULL DEFAULT '0',
  `default_timezone` VARCHAR( 32 ) NULL,
  PRIMARY KEY (`uid`),
  KEY `user_name` (`user_name`),
  KEY `email` (`email`),
  KEY `reputation` (`reputation`),
  KEY `reputation_update_time` (`reputation_update_time`),
  KEY `group_id` (`group_id`),
  KEY `agree_count` (`agree_count`),
  KEY `thanks_count` (`thanks_count`),
  KEY `forbidden` (`forbidden`),
  KEY `valid_email` (`valid_email`),
  KEY `last_active` (`last_active`),
  KEY `integral` (`integral`),
  KEY `url_token` (`url_token`),
  KEY `verified` (`verified`)
) ENGINE=MYISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users_attrib` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment id',
  `uid` int(11) DEFAULT NULL COMMENT 'User UID',
  `introduction` varchar(255) DEFAULT NULL COMMENT 'Profile',
  `signature` varchar(255) DEFAULT NULL COMMENT 'Personal signature',
  `ym` varchar(15) DEFAULT NULL,
  `homepage` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='User Additional property sheet';

CREATE TABLE `[#DB_PREFIX#]redirect` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(11) DEFAULT '0',
  `target_id` int(11) DEFAULT '0',
  `time` int(10) DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users_email_setting` (
  `email_setting_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment id',
  `uid` int(11) NOT NULL,
  `sender_11` tinyint(4) DEFAULT NULL COMMENT 'There are concerns me',
  `sender_12` tinyint(4) DEFAULT NULL COMMENT 'Someone asked me a question',
  `sender_13` tinyint(4) DEFAULT NULL COMMENT 'Answer a question someone asked me',
  `sender_14` tinyint(4) DEFAULT NULL COMMENT 'My concern with new posts',
  `sender_15` tinyint(4) DEFAULT NULL COMMENT 'Someone told me to send private messages',
  PRIMARY KEY (`email_setting_id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='E-mail notification settings';

CREATE TABLE `[#DB_PREFIX#]users_group` (
  `group_id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(3) DEFAULT '0' COMMENT '0-Member groups 1-System Group',
  `custom` tinyint(1) DEFAULT '0' COMMENT 'Whether custom',
  `group_name` varchar(50) NOT NULL,
  `reputation_lower` int(11) DEFAULT '0',
  `reputation_higer` int(11) DEFAULT '0',
  `reputation_factor` float DEFAULT '0' COMMENT 'Prestige factor',
  `permission` text COMMENT 'Competence Set',
  PRIMARY KEY (`group_id`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='User Groups';

CREATE TABLE `[#DB_PREFIX#]users_notification_setting` (
  `notice_setting_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment id',
  `uid` int(11) NOT NULL,
  `data` text COMMENT 'Setting Data',
  PRIMARY KEY (`notice_setting_id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Notification Settings';

CREATE TABLE `[#DB_PREFIX#]users_online` (
  `uid` int(11) NOT NULL COMMENT 'User ID',
  `last_active` INT( 11 ) NULL DEFAULT '0' COMMENT 'Last activity',
  `ip` BIGINT( 12 ) NULL DEFAULT '0' COMMENT 'Client ip',
  `active_url` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Visit page',
  `user_agent` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'User Client Information',
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Online User List';

CREATE TABLE `[#DB_PREFIX#]users_ym` (
  `id` bigint(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL COMMENT 'Users in the local UID',
  `type` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Category',
  `name` varchar(64) DEFAULT NULL COMMENT 'Microblogging nickname',
  `location` varchar(255) DEFAULT NULL COMMENT 'Address',
  `gender` varchar(8) DEFAULT NULL,
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `access_token` varchar(64) DEFAULT NULL,
  `oauth_token_secret` varchar(64) DEFAULT NULL,
  `nick` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users_sso` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT '0',
  `uc_uid` int(11) DEFAULT '0',
  `username` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]user_action_history` (
  `history_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `uid` int(11) NOT NULL COMMENT 'User id',
  `associate_type` tinyint(1) DEFAULT NULL COMMENT 'Association type: 1 Question 2 Answer 3 Comment 4 Topics',
  `associate_action` smallint(3) DEFAULT NULL COMMENT 'Type operation',
  `associate_id` int(11) DEFAULT NULL COMMENT 'Correlation ID',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  `associate_attached` int(11) DEFAULT NULL,
  `anonymous` TINYINT( 1 ) NULL DEFAULT '0' COMMENT 'Anonymous',
  PRIMARY KEY (`history_id`),
  KEY `add_time` (`add_time`),
  KEY `uid` (`uid`),
  KEY `associate_id` (`associate_id`),
  KEY `anonymous` (`anonymous`),
  KEY `associate` (`associate_type`,`associate_action`),
  KEY `associate_attached` (`associate_attached`),
  KEY `associate_with_id` ( `associate_id`, `associate_type`, `associate_action` )
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='User Action Record';

CREATE TABLE `[#DB_PREFIX#]user_action_history_data` (
  `history_id` int(11) unsigned NOT NULL,
  `associate_content` text,
  `associate_attached` text,
  `addon_data` TEXT NULL DEFAULT NULL COMMENT 'Additional Data',
  PRIMARY KEY (`history_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]user_follow` (
  `follow_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `fans_uid` int(11) DEFAULT NULL COMMENT 'Concerned about peoples UID',
  `friend_uid` int(11) DEFAULT NULL COMMENT 'Uid to be concerned about the human',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  PRIMARY KEY (`follow_id`),
  KEY `fans_uid` (`fans_uid`),
  KEY `friend_uid` (`friend_uid`),
  KEY `user_follow` ( `fans_uid`, `friend_uid` )
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Users concerned about the table';

CREATE TABLE `[#DB_PREFIX#]work_experience` (
  `work_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Increment ID',
  `uid` int(11) DEFAULT NULL COMMENT 'User ID',
  `start_year` int(11) DEFAULT NULL COMMENT 'Start Year',
  `end_year` int(11) DEFAULT NULL COMMENT 'End date',
  `company_name` varchar(64) DEFAULT NULL COMMENT 'Company name',
  `job_id` int(11) DEFAULT NULL COMMENT 'Job ID',
  `add_time` int(10) DEFAULT NULL COMMENT 'Add Time',
  PRIMARY KEY (`work_id`),
  KEY `uid` (`uid`)
) ENGINE=[#DB_ENGINE#]  DEFAULT CHARSET=utf8 COMMENT='Work Experience';

CREATE TABLE `[#DB_PREFIX#]reputation_category` (
  `auto_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `uid` INT(10) DEFAULT '0',
  `category_id` SMALLINT(4) DEFAULT '0',
  `update_time` INT(10) DEFAULT '0',
  `reputation` INT(10) DEFAULT '0',
  `thanks_count` INT(10) DEFAULT '0',
  `agree_count` INT(10) DEFAULT '0',
  `question_count` INT(10) DEFAULT '0',
  PRIMARY KEY (`auto_id`),
  UNIQUE KEY `uid_category_id` (`uid`,`category_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users_search` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `search_data` text,
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]users_forbidden` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `admin_uid` int(11) DEFAULT NULL,
  `status` tinyint(1) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]edm_task` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `message` mediumtext NOT NULL,
  `subject` varchar(255) NOT NULL,
  `from_name` varchar(255) NOT NULL,
  `time` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]edm_taskdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `taskid` int(11) NOT NULL,
  `email` varchar(255) NOT NULL,
  `sent_time` int(10) NOT NULL,
  `view_time` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `taskid` (`taskid`),
  KEY `sent_time` (`sent_time`),
  KEY `view_time` (`view_time`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]edm_unsubscription` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `email` varchar(255) NOT NULL,
  `time` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `email` (`email`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

CREATE TABLE `[#DB_PREFIX#]edm_userdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usergroup` int(11) NOT NULL,
  `email` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `usergroup` (`usergroup`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;


CREATE TABLE `[#DB_PREFIX#]edm_usergroup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `time` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;

INSERT INTO `[#DB_PREFIX#]admin_group`(`group_id`,`group_name`,`menu`,`no_menu`,`permission`,`no_permission`) VALUES
(1,'Super Admin','all',NULL,'all',NULL),
(2,'Administrator','all',NULL,'all',NULL),
(3,'Moderators','1,2,3,4,5,6',NULL,'',NULL);

INSERT INTO `[#DB_PREFIX#]category`(`title`,`type`) VALUES
('Category', 'question');

INSERT INTO `[#DB_PREFIX#]nav_menu`(`title`,`description`,`type`,`type_id`) VALUES
('Category', 'Default Category Description', 'category', 1);

INSERT INTO `[#DB_PREFIX#]jobs` (`id`, `job_name`) VALUES
(1, 'Accounting/Finance'),
(2, 'Administrative'),
(3, 'Arts/Entertainment/Publishing'),
(4, 'Banking/Loans'),
(5, 'Construction/Facilities'),
(6, 'Customer Service'),
(7, 'Education/Training'),
(8, 'Engineering/Architecture'),
(9, 'Government/Military'),
(10, 'Healthcare'),
(11, 'Computer/Internet'),
(12, 'Hospitality/Travel'),
(13, 'Human Resources'),
(14, 'Insurance'),
(15, 'Law Enforcement/Security'),
(16, 'Legal'),
(17, 'Maintenance'),
(18, 'Manufacturing/Mechanical'),
(19, 'Marketing/Advertising/PR'),
(20, 'Non-Profit/Volunteering'),
(21, 'Personal Services'),
(22, 'Pharmaceutical/Bio-tech'),
(23, 'Project Management'),
(24, 'Quality Assurance'),
(25, 'R&D'),
(26, 'Real Estate'),
(27, 'Restaurant/Food Service'),
(28, 'Retail'),
(29, 'Sales'),
(30, 'Security'),
(31, 'Technology'),
(32, 'Telecommunications'),
(33, 'Transportation/Logistics'),
(34, 'Upper Management/Consulting');

INSERT INTO `[#DB_PREFIX#]topic` (`topic_title`, `topic_description`) VALUES('Topics', 'Topics');

INSERT INTO `[#DB_PREFIX#]users_group` (`group_id`, `type`, `custom`, `group_name`, `reputation_lower`, `reputation_higer`, `reputation_factor`, `permission`) VALUES
(1, 0, 0, 'Super Admin', 0, 0, 5, 'a:7:{s:16:"is_administortar";s:1:"1";s:16:"publish_question";s:1:"1";s:13:"edit_question";s:1:"1";s:10:"edit_topic";s:1:"1";s:17:"redirect_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";}'),
(2, 0, 0, 'Reception Administrator', 0, 0, 4, 'a:7:{s:12:"is_moderator";s:1:"1";s:16:"publish_question";s:1:"1";s:13:"edit_question";s:1:"1";s:10:"edit_topic";s:1:"1";s:17:"redirect_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";}'),
(3, 0, 0, 'Unverified Member', 0, 0, 0, 'a:4:{s:16:"publish_question";s:1:"1";s:11:"human_valid";s:1:"1";s:19:"question_valid_hour";s:1:"2";s:17:"answer_valid_hour";s:1:"2";}'),
(4, 0, 0, 'Member', 0, 0, 0, 'a:5:{s:16:"publish_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"human_valid";s:1:"1";s:19:"question_valid_hour";s:2:"10";s:17:"answer_valid_hour";s:2:"10";}'),
(5, 1, 0, 'Register', 0, 100, 1, 'a:4:{s:16:"publish_question";s:1:"1";s:11:"human_valid";s:1:"1";s:19:"question_valid_hour";s:1:"5";s:17:"answer_valid_hour";s:1:"5";}'),
(6, 1, 0, 'Junior Member', 100, 200, 1, 'a:6:{s:16:"publish_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";s:11:"human_valid";s:1:"1";s:19:"question_valid_hour";s:1:"5";s:17:"answer_valid_hour";s:1:"5";}'),
(7, 1, 0, 'Intermediate Member', 200, 500, 1, 'a:5:{s:16:"publish_question";s:1:"1";s:10:"edit_topic";s:1:"1";s:17:"redirect_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";}'),
(8, 1, 0, 'Senior Member', 500, 1000, 1, 'a:6:{s:16:"publish_question";s:1:"1";s:13:"edit_question";s:1:"1";s:10:"edit_topic";s:1:"1";s:17:"redirect_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";}'),
(9, 1, 0, 'Core Member', 1000, 999999, 1, 'a:6:{s:16:"publish_question";s:1:"1";s:13:"edit_question";s:1:"1";s:10:"edit_topic";s:1:"1";s:17:"redirect_question";s:1:"1";s:13:"upload_attach";s:1:"1";s:11:"publish_url";s:1:"1";}'),
(99, 0, 0, 'Visitor', 0, 0, 0, 'a:8:{s:10:"visit_site";s:1:"1";s:13:"visit_explore";s:1:"1";s:12:"search_avail";s:1:"1";s:14:"visit_question";s:1:"1";s:11:"visit_topic";s:1:"1";s:13:"visit_feature";s:1:"1";s:12:"visit_people";s:1:"1";s:11:"answer_show";s:1:"1";}');
